﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Pizza
{
    internal abstract class Pizza
    {
        private void przygotuj()
        {
            przygotujCiasto();
            połóżSos();
            połóżSkładniki();
            połóżDodatki();
            upiecz();
        }

        public Pizza()
        {
            przygotuj();
        }

        protected abstract void przygotujCiasto();

        protected virtual void połóżSos()
        {
            Console.WriteLine("Smaruję keczupem");
        }

        protected abstract void połóżSkładniki();
        protected abstract void połóżDodatki();

        protected virtual float temperatura()
        {
            return 220;
        }

        private void upiecz()
        {
            Console.WriteLine($"Piękę przez 10 minut w temperaturze {temperatura()}");
        }
    }

    class Margarita : Pizza
    {
        protected override void przygotujCiasto()
        {
            Console.WriteLine("Przygotowuję cieńkie ciasto");
        }

        protected override void połóżSkładniki()
        {
            Console.WriteLine("Nie ma składników");
        }

        protected override void połóżDodatki()
        {
            Console.WriteLine("Dodaję żółty ser");
        }
    }

    class Sycylijska : Pizza
    {
        protected override void przygotujCiasto()
        {
            Console.WriteLine("Przygotowuję grube ciasto");
        }

        protected override void połóżSos()
        {
            Console.WriteLine("Kładę sos biały");
        }

        protected override void połóżSkładniki()
        {
            Console.WriteLine("Kładę szynkę, pomidora, rukola");
        }

        protected override void połóżDodatki()
        {
            Console.WriteLine("Dodaję ser mozarella");
        }

        protected override float temperatura()
        {
            return 180;
        }
    }
}
